unit BitrateCalculator;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Mask, Common, Math, Buttons;

type
  TfrmCalculs = class(TForm)
    GridPanel1: TGridPanel;
    Panel7: TPanel;
    calc1BV: TEdit;
    calc1BA: TComboBox;
    Panel8: TPanel;
    Panel5: TPanel;
    Label13: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Panel3: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Panel4: TPanel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel6: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    calc1T: TMaskEdit;
    Label6: TLabel;
    calc6BA: TComboBox;
    calc5BA: TComboBox;
    calc3BA: TComboBox;
    calc2BA: TComboBox;
    calc4BA: TComboBox;
    calc2TV: TEdit;
    calc6TV: TEdit;
    calc4S: TEdit;
    calc5S: TEdit;
    calc6S: TEdit;
    calc2T: TMaskEdit;
    calc4T: TMaskEdit;
    calc3BV: TEdit;
    calc5BV: TEdit;
    P2: TPanel;
    BQuit: TBitBtn;
    calc2BV: TEdit;
    calc4BV: TEdit;
    calc6BV: TEdit;
    calc3T: TMaskEdit;
    calc5T: TMaskEdit;
    calc6T: TMaskEdit;
    calc3TV: TEdit;
    calc1TV: TEdit;
    calc4TV: TEdit;
    calc5TV: TEdit;
    calc1S: TEdit;
    calc2S: TEdit;
    calc3S: TEdit;
    calc1TA: TEdit;
    calc2TA: TEdit;
    calc4TA: TEdit;
    calc3TA: TEdit;
    calc5TA: TEdit;
    calc6TA: TEdit;
    Label7: TLabel;
    procedure calcEditChange(Sender: TObject);
    procedure calcUpdate(Sender: TObject);     
    procedure calcBitrate();
    function T2S(Sender: TObject) : integer;
    procedure mefTaille(Obj: TEdit; Taille: double);
    procedure FormShow(Sender: TObject);
    procedure calcListChange(Sender: TObject);
    procedure BQuitClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  frmCalculs: TfrmCalculs;

implementation

{$R *.dfm}

//------------------------------------------------------------
procedure TfrmCalculs.mefTaille(Obj: TEdit; Taille: double);
begin
	if Taille < 1 then
	  Obj.Text := Str(Math.roundTo(taille*1000, 0)/1000)
  else if Taille < 10 then
		Obj.Text := Str(Math.roundTo(taille*100, 0)/100)
  else if Taille < 100 then
		Obj.Text := Str(Math.roundTo(taille*10, 0)/10)
  else
		Obj.Text := Str(Math.roundTo(taille, 0));
end;
//------------------------------------------------------------
procedure TfrmCalculs.calcListChange(Sender: TObject);
begin
  calcBitrate;
end;
//------------------------------------------------------------
procedure TfrmCalculs.BQuitClick(Sender: TObject);
begin
  Close;
end;
//------------------------------------------------------------
procedure TfrmCalculs.calcBitrate();
var
  ba, bv, ta, tv, s: double;
  t: integer;
begin
  // CAS 1
  ba := GetInteger(calc1BA.Items[calc1BA.ItemIndex]);
  bv := GetInteger(calc1BV.Text);
  t  := T2S(calc1T);
  tv := t*bv/(8*1024);
  ta := t*ba/(8*1024);
  mefTaille(calc1TV, tv);
  mefTaille(calc1TA, ta);
  mefTaille(calc1S, ta+tv);    
  // CAS 2
  ba := GetInteger(calc2BA.Items[calc2BA.ItemIndex]);
  tv := GetInteger(calc2TV.Text);
  t  := T2S(calc2T);
  if t = 0 then bv := 0 else bv := 8*1024*tv/t;
  ta := t*ba/(8*1024);
  calc2BV.Text := Str(floor(bv));
  mefTaille(calc2TA, ta);
  mefTaille(calc2S, ta+tv);
  // CAS 3
  ba := GetInteger(calc3BA.Items[calc3BA.ItemIndex]);
  bv := GetInteger(calc3BV.Text);
  tv := GetInteger(calc3TV.Text);   
  if bv = 0 then t := 0 else t := floor(8*1024*tv/bv);
  ta := t*ba/(8*1024);
  calc3T.Text := SecondsToTime(t);
  mefTaille(calc3TA, ta);
  mefTaille(calc3S, ta+tv);
  // CAS 4
  ba := GetInteger(calc4BA.Items[calc4BA.ItemIndex]);  
  t  := T2S(calc4T);
  s  := GetInteger(calc4S.Text);
  if t = 0 then bv := 0 else bv := 8*1024*s/t-ba;
  if bv < 0 then bv := 0;
  tv := t*bv/(8*1024);
  ta := t*ba/(8*1024);
  calc4BV.Text := str(floor(bv));
  mefTaille(calc4TV, tv);
  mefTaille(calc4TA, ta);
  // CAS 5
  ba := GetInteger(calc5BA.Items[calc5BA.ItemIndex]);
  bv := GetInteger(calc5BV.Text);
  s  := GetInteger(calc5S.Text);
  if ba+bv > 0 then t := floor(8*1024*s/(ba+bv)) else t := 0;
  tv := t*bv/(8*1024);
  ta := t*ba/(8*1024);
  mefTaille(calc5TV, tv);
  mefTaille(calc5TA, ta);
  calc5T.Text := SecondsToTime(t);
  // CAS 6
  ba := GetInteger(calc6BA.Items[calc6BA.ItemIndex]);
  tv := GetInteger(calc6TV.Text);            
  s  := GetInteger(calc6S.Text);
  ta := s - tv;
  if ta < 0 then ta := 0;
  if ba = 0 then t := 0 else t := floor(8*1024*ta/ba); 
  if t = 0 then bv := 0 else bv := 8*1024*tv/t;
  calc6BV.Text := str(floor(bv));
  mefTaille(calc6TA, ta);
  calc6T.Text := SecondsToTime(t);
end;
//------------------------------------------------------------
function TfrmCalculs.T2S(Sender: TObject) : integer;
begin
  result:= TimeToSeconds( TMaskEdit(Sender).Text);
end;
//------------------------------------------------------------
procedure TfrmCalculs.calcUpdate(Sender: TObject);
begin
  ValidTimeHMS(Sender);
  calcBitrate;
end;
//------------------------------------------------------------
procedure TfrmCalculs.FormShow(Sender: TObject);
begin
  calcBitrate;
end;
//------------------------------------------------------------
procedure TfrmCalculs.calcEditChange(Sender: TObject);
begin
  ValidInteger(Sender, 1, 9000);
  calcBitrate;
end;
//------------------------------------------------------------
end.
