unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, Buttons, StdCtrls, FileCtrl, ImgList, Menus, Mask,
  Common, CommonRegex, Tools, strutils;

type
  TfrmMain = class(TForm)
    Status: TStatusBar;
    PLeft: TPanel;
    PRight: TPanel;
    LImages: TImageList;
    pgControlLeft: TPageControl;
    TSrcVideo: TTabSheet;
    grpFolderIn: TGroupBox;
    LVideos: TFileListBox;
    P1: TPanel;
    EVideoIN: TEdit;
    grpFolderOut: TGroupBox;
    EVideoOUT: TEdit;
    BVideoOUT: TSpeedButton;
    BVideoIN: TSpeedButton;
    P2: TPanel;
    BQuit: TBitBtn;
    Panel1: TPanel;
    BGo: TBitBtn;
    pgControlRight: TPageControl;
    Panel2: TPanel;
    BVideoSelectAll: TSpeedButton;
    BVideoRefresh: TSpeedButton;
    BVideoDeselect: TSpeedButton;
    BVideoSelectInvert: TSpeedButton;
    btnCalc: TBitBtn;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TDVDPAL: TTabSheet;
    DVDPALFormat: TLabeledEdit;
    DVDPALVideoBitrate: TLabeledEdit;
    DVDPALAspect: TComboBox;
    Label9: TLabel;
    Label10: TLabel;
    DVDPALAudioBitrate: TComboBox;
    DVDPALAudioCodec: TComboBox;
    Label11: TLabel;
    Panel3: TPanel;
    Label3: TLabel;
    ALLEndPosType: TComboBox;
    ALLEndPos: TCheckBox;
    ALLEndPosValue: TEdit;
    TDVDNTSC: TTabSheet;
    DVDNTSCFormat: TLabeledEdit;
    DVDNTSCVideoBitrate: TLabeledEdit;
    DVDNTSCAspect: TComboBox;
    DVDNTSCAudioBitrate: TComboBox;
    DVDNTSCAudioCodec: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    DVDNTSCFrameRate: TComboBox;
    DVDPALFrameRate: TComboBox;
    Label12: TLabel;
    MPEG2: TTabSheet;
    MPEG2FrameRate: TComboBox;
    MPEG2AudioCodec: TComboBox;
    MPEG2AudioBitrate: TComboBox;
    MPEG2Aspect: TComboBox;
    MPEG2VideoBitrate: TLabeledEdit;
    MPEG2Format: TLabeledEdit;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    MPEG2FormatFlag: TCheckBox;
    TabSheet2: TTabSheet;
    Panel8: TPanel;
    TabSheet3: TTabSheet;
    Panel10: TPanel;
    Invert: TCheckBox;
    Panel15: TPanel;
    Grayscale: TCheckBox;
    Panel12: TPanel;
    LContrast: TLabel;
    Contrast: TCheckBox;
    ContrastBar: TTrackBar;
    Panel14: TPanel;
    LSaturation: TLabel;
    Saturation: TCheckBox;
    SaturationBar: TTrackBar;
    Panel13: TPanel;
    LBrightness: TLabel;
    Brightness: TCheckBox;
    BrightnessBar: TTrackBar;
    Panel11: TPanel;
    LGamma: TLabel;
    Gamma: TCheckBox;
    GammaBar: TTrackBar;
    TabSheet4: TTabSheet;
    Panel6: TPanel;
    Rotate: TCheckBox;
    Rotate90: TRadioButton;
    Rotate90Anti: TRadioButton;
    Rotate180: TRadioButton;
    Panel9: TPanel;
    FlipV: TCheckBox;
    Panel7: TPanel;
    FlipH: TCheckBox;
    Panel5: TPanel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    VFExpand: TCheckBox;
    VFExpandW: TEdit;
    VFExpandH: TEdit;
    VFExpandY: TEdit;
    VFExpandX: TEdit;
    Panel4: TPanel;
    Label7: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    VFCrop: TCheckBox;
    VFCropW: TEdit;
    VFCropH: TEdit;
    VFCropY: TEdit;
    VFCropX: TEdit;
    Panel16: TPanel;
    Noise: TCheckBox;
    NoiseValue: TTrackBar;
    Panel17: TPanel;
    Denoise: TCheckBox;
    DenoiseValue: TTrackBar;
    NoiseType: TComboBox;
    Panel18: TPanel;
    Blur: TCheckBox;
    BlurValue: TTrackBar;
    Panel19: TPanel;
    Label4: TLabel;
    ALLStartAtType: TComboBox;
    ALLStartAt: TCheckBox;
    ALLStartAtValue: TEdit;
    TabSheet5: TTabSheet;
    MPEG4Format: TLabeledEdit;
    MPEG4VideoBitrate: TLabeledEdit;
    MPEG4Aspect: TComboBox;
    MPEG4AudioBitrate: TComboBox;
    MPEG4AudioCodec: TComboBox;
    MPEG4FrameRate: TComboBox;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    MPEG4FormatFlag: TCheckBox;
    MPEG4Quality: TComboBox;
    Label28: TLabel;
    Label29: TLabel;
    TabSheet6: TTabSheet;
    GroupBox1: TGroupBox;
    LDiapos: TFileListBox;
    Panel20: TPanel;
    BDiapoIn: TSpeedButton;
    EDiapoIN: TEdit;
    Panel21: TPanel;
    BDiapoSelectAll: TSpeedButton;
    BDiapoRefresh: TSpeedButton;
    BDiapoDeselect: TSpeedButton;
    BDiapoSelectInvert: TSpeedButton;
    GroupBox2: TGroupBox;
    BDiapoOUT: TSpeedButton;
    EDiapoOUT: TEdit;
    LaunchDVDStyler: TBitBtn;
    Panel22: TPanel;
    LaunchMPUI: TBitBtn;
    Panel23: TPanel;
    Panel24: TPanel;
    Label5: TLabel;
    DiapoDelay: TEdit;
    Label30: TLabel;
    TransitionDelay: TEdit;
    LTransitions: TComboBox;
    Label31: TLabel;
    Panel25: TPanel;
    LDiapoLength: TLabel;
    Label32: TLabel;
    BTransitionHelp: TSpeedButton;
    Panel26: TPanel;
    LDiapoSize: TLabel;
    Label34: TLabel;
    TabSheet7: TTabSheet;
    FLVVideoBitrate: TLabeledEdit;
    FLVFormat: TLabeledEdit;
    FLVAspect: TComboBox;
    FLVAudioBitrate: TComboBox;
    FLVAudioCodec: TComboBox;
    FLVFrameRate: TComboBox;
    Label33: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    FLVFormatFlag: TCheckBox;
    chkJoin: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure BVideoOUTClick(Sender: TObject);
    procedure BVideoINClick(Sender: TObject);
    procedure EVideoINChange(Sender: TObject);
    procedure EVideoOUTChange(Sender: TObject);
    procedure BQuitClick(Sender: TObject);
    procedure BVideoRefreshClick(Sender: TObject);
    procedure BVideoDeselectClick(Sender: TObject);
    procedure BVideoSelectAllClick(Sender: TObject);
    procedure BVideoSelectInvertClick(Sender: TObject);
    procedure ALLEndPosValueChange(Sender: TObject);
    procedure btnCalcClick(Sender: TObject);
    procedure BGoClick(Sender: TObject);
    procedure BitrateChange(Sender: TObject);
    procedure FormatChange(Sender: TObject);
    procedure MPEG2FormatFlagClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure IntegerChange(Sender: TObject);
    procedure Rotate180Click(Sender: TObject);
    procedure Rotate90Click(Sender: TObject);
    procedure Rotate90AntiClick(Sender: TObject);
    procedure FlipClick(Sender: TObject);
    procedure GammaBarChange(Sender: TObject);
    procedure ContrastBarChange(Sender: TObject);
    procedure BrightnessBarChange(Sender: TObject);
    procedure SaturationBarChange(Sender: TObject);
    procedure GrayscaleClick(Sender: TObject);
    procedure BGEQClick(Sender: TObject);
    procedure BlurValueChange(Sender: TObject);
    procedure DenoiseValueChange(Sender: TObject);
    procedure NoiseValueChange(Sender: TObject);
    procedure BlurClick(Sender: TObject);
    procedure DenoiseClick(Sender: TObject);
    procedure NoiseClick(Sender: TObject);
    procedure ALLStartAtValueChange(Sender: TObject);
    procedure GammaClick(Sender: TObject);
    procedure ContrastClick(Sender: TObject);
    procedure BrightnessClick(Sender: TObject);
    procedure SaturationClick(Sender: TObject);
    procedure pgControlRightChange(Sender: TObject);
    procedure MPEG4FormatFlagClick(Sender: TObject);
    procedure BDiapoInClick(Sender: TObject);
    procedure BDiapoSelectAllClick(Sender: TObject);
    procedure BDiapoDeselectClick(Sender: TObject);
    procedure BDiapoSelectInvertClick(Sender: TObject);
    procedure BDiapoRefreshClick(Sender: TObject);
    procedure BDiapoOUTClick(Sender: TObject);
    procedure EDiapoOUTChange(Sender: TObject);
    procedure EDiapoINChange(Sender: TObject);
    procedure RegLoadFolder(Key: string; Edit: TEdit);
    procedure LaunchMPUIClick(Sender: TObject);
    procedure LaunchDVDStylerClick(Sender: TObject);
    procedure FloatChange(Sender: TObject);
    procedure BTransitionHelpClick(Sender: TObject);
    procedure UpdDiapoLength(Sender: TObject);
    procedure LVideosChange(Sender: TObject);
    procedure FLVFormatFlagClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    BinMencoder:string;
    BinConvert:string;
    BinComposite:string;
    BinMogrify:string;
    BinMPUI:string;
    BinDVDStyler:string;
  end;

var
  frmMain: TfrmMain;
const
  sFilterVideos = '*.avi;*.asf;*.dat;*.divx;*.fli;*.flv;*.mod;*.dv;*.mov;*.mp2;*.mp3;*.mp4;*.mpeg;*.mpg;*.nsa;*.nsv;*.nuv;*.ogg;*.ogm;*.pva;*.rm;*.sdp;*.vob;*.vp3;*.vp5;*.vp6;*.wav;*.wma;*.wmv;*.xvid';
  sFilterJPG = '*.jpg;*.jpeg;*.png';
  REGROOTKEY = '\Software\Arnapou\MEncoderGUI';

implementation

uses BitrateCalculator, Encodage, WinManager, RegTools, TransitionHelp, VBSBuilder;

{$R *.dfm}

{************************ DIAPOSITIVES ************************}
procedure TfrmMain.BDiapoInClick(Sender: TObject);
begin
  SelectFolder(EDiapoIN, 'Slectionnez un dossier:');
end;
//------------------------------------------------------------
procedure TfrmMain.BDiapoOUTClick(Sender: TObject);
begin
  SelectFolder(EDiapoOUT, 'Slectionnez un dossier:');
end;
//------------------------------------------------------------
procedure TfrmMain.BDiapoRefreshClick(Sender: TObject);
begin
  FileListRefresh(LDiapos);
end;
//------------------------------------------------------------
procedure TfrmMain.BDiapoDeselectClick(Sender: TObject);
begin
  ListBoxDeselect(LDiapos);
end;
//------------------------------------------------------------
procedure TfrmMain.BDiapoSelectAllClick(Sender: TObject);
begin
  ListBoxSelectAll(LDiapos);
end;
//------------------------------------------------------------
procedure TfrmMain.BDiapoSelectInvertClick(Sender: TObject);
begin
  ListBoxSelectInvert(LDiapos);
end;          
//------------------------------------------------------------
procedure TfrmMain.EDiapoOUTChange(Sender: TObject);
begin
  ValidFolder(EDiapoOUT);
end;                            
//------------------------------------------------------------
procedure TfrmMain.EDiapoINChange(Sender: TObject);
begin
  if ValidFolder(EDiapoIN) then LDiapos.Directory := EDiapoIN.Text;
end;
{*************************** VIDEOS ***************************}
procedure TfrmMain.BVideoINClick(Sender: TObject);
begin
  SelectFolder(EVideoIN, 'Slectionnez un dossier:');
end;    
//------------------------------------------------------------
procedure TfrmMain.BVideoRefreshClick(Sender: TObject);
begin
  FileListRefresh(LVideos);
end;
//------------------------------------------------------------
procedure TfrmMain.BVideoSelectAllClick(Sender: TObject);
begin
  ListBoxSelectAll(LVideos);
end;  
//------------------------------------------------------------
procedure TfrmMain.BVideoDeselectClick(Sender: TObject);
begin
  ListBoxDeselect(LVideos);
end;
//------------------------------------------------------------
procedure TfrmMain.BVideoSelectInvertClick(Sender: TObject);
begin
  ListBoxSelectInvert(LVideos);
end;
//------------------------------------------------------------
procedure TfrmMain.BVideoOUTClick(Sender: TObject);
begin
  SelectFolder(EVideoOUT, 'Slectionnez un dossier:');
end;  
//------------------------------------------------------------
procedure TfrmMain.EVideoINChange(Sender: TObject);
begin
  if ValidFolder(EVideoIN) then LVideos.Directory := EVideoIN.Text;
end;
//------------------------------------------------------------
procedure TfrmMain.EVideoOUTChange(Sender: TObject);
begin
  ValidFolder(EVideoOUT);
end;                
{*************************** AUTRES ***************************}
procedure TfrmMain.BGEQClick(Sender: TObject);
begin
  frmTransitionHelp.ShowModal;
end;                                          
//------------------------------------------------------------
procedure TfrmMain.ALLStartAtValueChange(Sender: TObject);
begin
  if InStr(ALLStartAtValue.Text, ':') > 0 then
    ValidRegex(ALLStartAtValue, PATTERN_HHMMSS)
  else begin
    ALLStartAtValue.Font.Color := clWindowText;
    ValidInteger(ALLStartAtValue);
  end;
end;
//------------------------------------------------------------
procedure TfrmMain.BGoClick(Sender: TObject);
var
  cmd: TCMD;
  i, j, n1, n2: integer;
  f, dImg, dTrans, Freq: double;
  ok, Exists: boolean;
  ext, tmp, sIn, sOut, TmpFolder, fmt, Delay, sNow : string;
  ListCOPY, ListTMP, ListENCODE, ListDELETE: TStringList;
begin
  ok := true;
  cmd := TCMD.Create;

  // construit la ligne de commande
  case pgControlRight.ActivePageIndex of
    0: begin //.................... DVD PAL ....................
      cmd.AB         := DVDPALAudioBitrate.Text;
      cmd.VB         := DVDPALVideoBitrate.Text;
      cmd.Aspect     := DVDPALAspect.Text;
      cmd.Format     := DVDPALFormat.Text;
      cmd.AudioCodec := DVDPALAudioCodec.Text;
      cmd.FrameRate  := DVDPALFrameRate.Text;
      cmd.Encodage   := 'DVDPAL';
      ext            := 'mpg';
    end;
    1: begin //.................... DVD NTSC ....................
      cmd.AB         := DVDNTSCAudioBitrate.Text;
      cmd.VB         := DVDNTSCVideoBitrate.Text;
      cmd.Aspect     := DVDNTSCAspect.Text;
      cmd.Format     := DVDNTSCFormat.Text;
      cmd.AudioCodec := DVDNTSCAudioCodec.Text;
      cmd.FrameRate  := DVDNTSCFrameRate.Text;
      cmd.Encodage   := 'DVDNTSC';
      ext            := 'mpg';
    end;
    2: begin //.................... DVD MPEG 2 ....................
      cmd.AB         := MPEG2AudioBitrate.Text;
      cmd.VB         := MPEG2VideoBitrate.Text;
      cmd.Aspect     := MPEG2Aspect.Text;
      cmd.Format     := MPEG2Format.Text;
      cmd.AudioCodec := MPEG2AudioCodec.Text;
      cmd.FrameRate  := MPEG2FrameRate.Text;
      cmd.Encodage   := 'MPEG2';
      ext            := 'mpg';
      if MPEG2Format.Enabled then ok := CheckFormat(cmd.Format)
      else cmd.Format := '-1:-1';
    end;    
    3: begin //.................... MPEG 4 ....................
      cmd.AB         := MPEG4AudioBitrate.Text;
      cmd.VB         := MPEG4VideoBitrate.Text;
      cmd.Aspect     := MPEG4Aspect.Text;
      cmd.Format     := MPEG4Format.Text;
      cmd.AudioCodec := MPEG4AudioCodec.Text;
      cmd.FrameRate  := MPEG4FrameRate.Text;
      cmd.Encodage   := 'MPEG4';
      ext            := 'mp4';
      if MPEG4Format.Enabled then ok := CheckFormat(cmd.Format)
      else cmd.Format := '-1:-1';
      cmd.Quality := MPEG4Quality.ItemIndex;
    end;
    4: begin //.................... FLV ....................
      cmd.AB         := FLVAudioBitrate.Text;
      cmd.VB         := FLVVideoBitrate.Text;
      cmd.Aspect     := FLVAspect.Text;
      cmd.Format     := FLVFormat.Text;
      cmd.AudioCodec := FLVAudioCodec.Text;
      cmd.FrameRate  := FLVFrameRate.Text;
      cmd.Encodage   := 'FLV';
      ext            := 'flv';
      if FLVFormat.Enabled then ok := CheckFormat(cmd.Format)
      else cmd.Format := '-1:-1';
    end;
  end;

  // vrifie la validit des dossiers sources et destination
  if ok and not(ValidFolder(EVideoIn)) then begin
    showmessage('Le dossier source n''existe pas !');
    ok := false;
  end;
  if ok and not(ValidFolder(EVideoOut)) then begin
    showmessage('Le dossier destination n''existe pas !');
    ok := false;
  end;        
  if ok and (GetDirSlash(EVideoIn.Text)=GetDirSlash(EVideoOut.Text)) then begin
    showmessage('Les dossiers source et destination doivent tre diffrents !');
    ok := false;
  end;

  // inversion des couleurs                            
  cmd.Invert := Invert.Checked;
  // flip
  cmd.FlipV := FlipV.Checked;
  cmd.FlipH := FlipH.Checked;
  // rotate
  if Rotate.Checked then begin
    cmd.Rot90  := Rotate90.Checked;
    cmd.Rot90A := Rotate90Anti.Checked;
  end;
  // Noise
  if Noise.Checked then begin
    case AnsiIndexStr(NoiseType.Text, ['uniforme', 'temporel', 'haute qualit', 'alatoire']) of
      0: cmd.Noise := Str(NoiseValue.Position)+'u:'+Str(NoiseValue.Position)+'u';
      1: cmd.Noise := Str(NoiseValue.Position)+'t:'+Str(NoiseValue.Position)+'t';
      2: cmd.Noise := Str(NoiseValue.Position)+'h:'+Str(NoiseValue.Position)+'h';
      3: cmd.Noise := Str(NoiseValue.Position)+'p:'+Str(NoiseValue.Position)+'p';
    end;
  end;
  if Denoise.Checked then begin
    cmd.Denoise := Str(DenoiseValue.Position)+':'+Str(DenoiseValue.Position)+':'+Str(DenoiseValue.Position);
  end;
  // Flou / Nettet
  if Blur.Checked then begin
    {f := 5*2*(BlurValue.Position-BlurValue.Max/2)/BlurValue.Max;
    cmd.Unsharp := 'l3x3:'+CmdFloat(f)+':l3x3:'+CmdFloat(f);}
    f := -2*(BlurValue.Position-BlurValue.Max/2)/BlurValue.Max;
    cmd.Blur := '4:'+CmdFloat(f)+':0';
  end;
  // gamma
  if Gamma.Checked      then cmd.Gamma      := LGamma.caption;
  if Contrast.Checked   then cmd.Contrast   := LContrast.caption;
  if Brightness.Checked then cmd.Brightness := LBrightness.caption;
  if Saturation.Checked then cmd.Saturation := LSaturation.caption; 
  // start at
  if ALLStartAt.Checked then begin
    if (InStr(ALLStartAtValue.Text, ':')>0) and Not(ValidRegex(ALLStartAtValue, PATTERN_HHMMSS)) then begin
      showmessage('La valeur HH:MM:SS de ''Dbut '' n''est pas valide !');
      ok := false;
    end;
    cmd.StartAt := ALLStartAtValue.Text;
  end;
  // end pos
  if ALLEndPos.Checked then begin
    if length(ALLEndPosType.Text)=2 then begin
      if InStr(ALLEndPosValue.Text, ':')>0 then begin
        showmessage('Si la valeur ''Fin '' est au format HH:MM:SS, slectionnez le bon lment dans la liste !');
        ok := false;
      end else
        cmd.EndPos := ALLEndPosValue.Text+StrLower(PAnsiChar(ALLEndPosType.Text));
    end else begin
      if (InStr(ALLEndPosValue.Text, ':')>0) and Not(ValidRegex(ALLEndPosValue, PATTERN_HHMMSS)) then begin
        showmessage('La valeur HH:MM:SS de ''Fin '' n''est pas valide !');
        ok := false;
      end;
      cmd.EndPos := ALLEndPosValue.Text;
    end;
  end;
  // crop
  if VFCrop.Checked then cmd.Crop := VFCropW.Text+':'+VFCropH.Text+':'+VFCropX.Text+':'+VFCropY.Text;
  if VFExpand.Checked then cmd.Expand := VFExpandW.Text+':'+VFExpandH.Text+':'+VFExpandX.Text+':'+VFExpandY.Text;

  // met  jour la ligne de commande
  tmp := cmd.GetCmd;
  ok := ok and cmd.OK;

  sNow := StrReplace(StrReplace(StrReplace(GetNow, '/', '-'), ':', '-'), ' ', '_');
  frmEncode.tmpDir := GetTempDirectory+'Diaporama_'+sNow;

  // vrifie la slection des fichiers
  frmEncode.Items.Clear;
  frmEncode.Commands.Clear;
  Exists := False;
  case pgControlLeft.ActivePageIndex of
    0: begin  //........... VIDEOS .............  
      frmEncode.isJoin:= chkJoin.Checked;      
      frmEncode.nbJoin:= 0;
      if Not(chkJoin.Checked) then begin
        for I := 0 to LVideos.Count - 1 do begin
          if LVideos.Selected[i] then begin
            sIn  := GetDirSlash(EVideoIn.Text) + LVideos.Items[i];
            sOut := GetDirSlash(EVideoOut.Text) + RegReplace(LVideos.Items[i],'\.[a-zA-Z0-9]{1,5}$', '.'+ext);
            tmp := '"'+BinMencoder+'" '+cmd.GetCmd+' -o "'+sOut+'" "'+sIn+'" ';
            frmEncode.Commands.Add(tmp);
            frmEncode.Items.Add(LVideos.Items[i]);
            Exists := Exists or FileExists(sOut);
          end;
        end;
      end else begin
        sIn := '';
        for I := 0 to LVideos.Count - 1 do begin
          if LVideos.Selected[i] then begin
            sIn := sIn+' "'+GetDirSlash(EVideoIn.Text) + LVideos.Items[i]+'"';
            frmEncode.nbJoin := frmEncode.nbJoin + 1;
          end;
        end;
        if (sIn <> '') then begin    
          sOut := GetDirSlash(EVideoOut.Text) + 'Join_' + sNow + '.' + ext;
          tmp := '"'+BinMencoder+'" '+cmd.GetCmd+' -o "'+sOut+'"'+sIn;
          frmEncode.Commands.Add(tmp);
          frmEncode.Items.Add('Join_' + sNow + '.' + ext);
          Exists := FileExists(sOut);
        end;
      end;
    end; 
    1: begin  //........... DIAPORAMA .............
      mkdir(frmEncode.tmpDir);
      TmpFolder := GetDirSlash(frmEncode.tmpDir);
      if Not(DirectoryExists(frmEncode.tmpDir)) then begin
        showmessage('Problme de cration de dossier temporaire !');
        ok := false;
      end;
      if cmd.Format = '-1:-1' then begin
        showmessage('Pour le diaporama, vous DEVEZ prciser le format de sortie (largeur:hauteur) !');
        ok := false;
      end;
      if ok then begin
        ListCOPY   := TStringList.Create;
        ListTMP    := TStringList.Create;
        ListDELETE := TStringList.Create;
        ListENCODE := TStringList.Create;
        // prpare la liste
        for I := 0 to LDiapos.Count - 1 do begin
          if LDiapos.Selected[i] then begin
            ListCOPY.Add(LDiapos.Items[i]);
          end;
        end;
        if ListCOPY.Count>0 then begin
          // init
          fmt := StrReplace(cmd.Format, ':', 'x');
          Delay := '1/'+DiapoDelay.Text;
          // rcupre les dures
          val(DiapoDelay.Text          , dImg, i);
          val(TransitionDelay.Text     , dTrans, i);
          val(LeftStr(cmd.FrameRate, 2), Freq, i);
          // commandes de copie
          frmEncode.Commands.Add(WriteVBSCopy(TmpFolder, EDiapoIn.Text, ListCOPY, ListTMP));
          frmEncode.Items.Add('Copie des images dans un dossier temporaire');
          // commandes de conversion
          frmEncode.Commands.Add(WriteVBSConvert(TmpFolder, fmt, ListTMP, ListDELETE));
          frmEncode.Items.Add('Prparation des fichiers pour l''encodage');
          // transitions                
          n1 := ToInt(dImg*Freq);   if n1=0 then n1 := 1;
          n2 := ToInt(dTrans*Freq);         
          WriteFondJPG(TmpFolder+'f-o-n-d.jpg');
          case LTransitions.ItemIndex of
            0: begin
              for i := 0 to ListTMP.Count - 1 do begin
                ListENCODE.Add(ListTMP[i]);
              end;
            end;
            1: begin // ecran noir
              //frmEncode.Commands.Add('"'+BinMogrify+'" -resize "'+fmt+'!" -quality 100% -compress LossLess -colorspace YUV "'+TmpFolder+'f-o-n-d.jpg"');
              //frmEncode.Items.Add('Cration de l''cran noir');
              ListDELETE.Add('f-o-n-d.jpg');
              for i := 0 to ListTMP.Count - 1 do begin
                for j := 1 to n1 do ListENCODE.Add(ListTMP[i]);
                for j := 1 to n2 do ListENCODE.Add('f-o-n-d.jpg');
              end;
              Delay := Str(Freq);
            end;
            2: begin // fusion
              frmEncode.Commands.Add(WriteVBSTFusion(TmpFolder, ListTMP, ListENCODE, ListDELETE, N1, N2));
              frmEncode.Items.Add('Prparation des transitions'); 
              Delay := Str(Freq);
            end;
          end;
          // fichier list.txt
          WriteListeTXT(TmpFolder, ListENCODE);
          // Encodage
          frmEncode.Commands.Add(
              '"'+BinMencoder+'" mf://@"'+TmpFolder+'list.txt" -mf fps='+Delay
              +' '+cmd.GetCmd+' -o "'+GetDirSlash(EDiapoOut.Text)+
              BaseName(frmEncode.tmpDir)+'.'+ext+'"');
          frmEncode.Items.Add('Encodage de la vido');
          // commandes de suppression
          frmEncode.Commands.Add(WriteVBSDelete(TmpFolder, ListDELETE));
          frmEncode.Items.Add('Suppression des images temporaires');
        end;
        ListCOPY.Free; 
        ListDELETE.Free;
        ListTMP.Free;   
        ListENCODE.Free;
      end;
    end;
  end;

  if ok and Exists then begin
    if Not(MsgConfirm('Certains de fichiers de destination vont tre crass !'+CRLF+
      'Etes-vous sr de vouloir continuer ?', 'Attention')) then ok := false;
  end;
  if ok and (frmEncode.Items.Count=0) then begin
    showmessage('Vous devez slectionner au moins un fichier source !');
    ok := false;
  end;

  // affiche la fenetre
  if ok then WinManager.ShowModal(frmEncode, Self);

end;
//------------------------------------------------------------
procedure TfrmMain.BQuitClick(Sender: TObject);
begin
  Close;
end;
//------------------------------------------------------------
procedure TfrmMain.btnCalcClick(Sender: TObject);
begin
  frmCalculs.ShowModal;
end;
//------------------------------------------------------------
procedure TfrmMain.BitrateChange(Sender: TObject);
begin
  ValidInteger(Sender, 1, 9800);
end;         
//------------------------------------------------------------
procedure TfrmMain.BlurClick(Sender: TObject);
begin
  if Not(Blur.Checked) then BlurValue.Position := 100;
end;                       
//------------------------------------------------------------
procedure TfrmMain.BTransitionHelpClick(Sender: TObject);
begin
  //
end;
//------------------------------------------------------------
procedure TfrmMain.BlurValueChange(Sender: TObject);
begin
  if BlurValue.Position=100 then begin
    Blur.Checked := False;
    Blur.Caption := 'Flou/Nettet'
  end else if BlurValue.Position>100 then begin 
    Blur.Checked := True;
    Blur.Caption := 'Nettet'
  end else if BlurValue.Position<100 then begin 
    Blur.Checked := True;
    Blur.Caption := 'Flou';
  end;
end;
//------------------------------------------------------------
procedure TfrmMain.ALLEndPosValueChange(Sender: TObject);
begin
  if InStr(ALLEndPosValue.Text, ':') > 0 then
    ValidRegex(ALLEndPosValue, PATTERN_HHMMSS)
  else begin
    ALLEndPosValue.Font.Color := clWindowText;
    ValidInteger(ALLEndPosValue);
  end;
end;
//------------------------------------------------------------
procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  RegWriteKeyCU(REGROOTKEY, 'FolderSource', EVideoIN.Text);
  RegWriteKeyCU(REGROOTKEY, 'FolderDestination', EVideoOUT.Text);
  RegWriteKeyCU(REGROOTKEY, 'DiaposSource', EDiapoIN.Text);
  RegWriteKeyCU(REGROOTKEY, 'DiaposDestination', EDiapoOUT.Text);
  RegFormSaveCU(Self, REGROOTKEY);
end;
//------------------------------------------------------------
procedure TfrmMain.RegLoadFolder(Key: string; Edit: TEdit);
var sFolder : string;
begin
  sFolder := RegReadKeyCU(REGROOTKEY, Key);
  if (sFolder<>'') and DirectoryExists(sFolder) then Edit.Text := sFolder
                                                else Edit.Text := HomeDir;
end;
//------------------------------------------------------------
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  RegLoadFolder('FolderSource', EVideoIN); 
  RegLoadFolder('FolderDestination', EVideoOUT);
  RegLoadFolder('DiaposSource', EDiapoIN);
  RegLoadFolder('DiaposDestination', EDiapoOUT);

  RegFormLoadCU(Self, REGROOTKEY);

  LVideos.Directory := EVideoIN.Text;
  LVideos.Mask := sFilterVideos;

  LDiapos.Directory := EDiapoIN.Text;
  LDiapos.Mask := sFilterJPG;
  If DirectoryExists(HomeDir+'MPlayer') then begin
    BinMencoder  := HomeDir+'MPlayer\mencoder.exe';
    BinConvert   := HomeDir+'ImageMagick\convert.exe';
    BinComposite := HomeDir+'ImageMagick\composite.exe';
    BinMogrify   := HomeDir+'ImageMagick\mogrify.exe';
    BinMPUI      := HomeDir+'MPlayer\MPUI.exe';
    BinDVDStyler := HomeDir+'DVDStyler\bin\DVDStyler.exe';
  end else begin
    BinMencoder  := RegReplace(HomeDir, '[^\\]+\\$', '')+'MPlayer\mencoder.exe';
    BinConvert   := RegReplace(HomeDir, '[^\\]+\\$', '')+'ImageMagick\convert.exe';
    BinComposite := RegReplace(HomeDir, '[^\\]+\\$', '')+'ImageMagick\composite.exe';
    BinMogrify   := RegReplace(HomeDir, '[^\\]+\\$', '')+'ImageMagick\mogrify.exe';
    BinMPUI      := RegReplace(HomeDir, '[^\\]+\\$', '')+'MPlayer\MPUI.exe';
    BinDVDStyler := RegReplace(HomeDir, '[^\\]+\\$', '')+'DVDStyler\bin\DVDStyler.exe';
  end;
                                        
  pgControlLeft.ActivePageIndex := 0;
  pgControlRight.ActivePageIndex := 0;

//  WinManager.WinCreate(Application.Handle);
end;
//------------------------------------------------------------
procedure TfrmMain.FormShow(Sender: TObject);
begin
//  WinManager.WinTaskbarShow(Self.Handle);
end;
//------------------------------------------------------------
procedure TfrmMain.GammaBarChange(Sender: TObject);
var
  val: string;
begin
  if GammaBar.position<18 then begin
    val := cmdFloat(0.10+0.05*GammaBar.Position);
    Gamma.Checked := True;
  end else begin
    val := cmdFloat(1.0+0.5*(GammaBar.Position-18));
    if GammaBar.position=18 then Gamma.Checked := False
                            else Gamma.Checked := True;
  end;
  LGamma.Caption := Val;
end;
//------------------------------------------------------------
procedure TfrmMain.GammaClick(Sender: TObject);
begin
  if Not(Gamma.Checked) then GammaBar.Position := 18;
end;
//------------------------------------------------------------
procedure TfrmMain.GrayscaleClick(Sender: TObject);
begin
  if Grayscale.Checked then begin
    SaturationBar.Position := 0;
    Saturation.checked := True;
  end else Saturation.checked := False;
end;
//------------------------------------------------------------
procedure TfrmMain.ContrastBarChange(Sender: TObject);
begin                   
  LCOntrast.Caption := CmdFloat(0.05*ContrastBar.Position);
  if COntrastBar.Position=20 then COntrast.Checked := False
                             else COntrast.Checked := True;
end;                       
//------------------------------------------------------------
procedure TfrmMain.ContrastClick(Sender: TObject);
begin
  if Not(Contrast.Checked) then ContrastBar.Position := 20;
end;
//------------------------------------------------------------
procedure TfrmMain.DenoiseClick(Sender: TObject);
begin
  if Not(Denoise.Checked) then DenoiseValue.Position := 0;
end;
//------------------------------------------------------------
procedure TfrmMain.DenoiseValueChange(Sender: TObject);
begin
  if DenoiseValue.Position>0 then Denoise.Checked := True
                             else Denoise.Checked := False;
end;
//------------------------------------------------------------
procedure TfrmMain.BrightnessBarChange(Sender: TObject);
begin
  LBrightness.Caption := CmdFloat(0.05*BrightnessBar.Position-1);
  if BrightnessBar.Position=20 then Brightness.Checked := False
                               else Brightness.Checked := True;
end;                
//------------------------------------------------------------
procedure TfrmMain.BrightnessClick(Sender: TObject);
begin
  if Not(Brightness.Checked) then BrightnessBar.Position := 20;
end;
//------------------------------------------------------------
procedure TfrmMain.SaturationBarChange(Sender: TObject);
begin            
  if SaturationBar.Position=20 then Saturation.Checked := False
                               else Saturation.Checked := True;
  if SaturationBar.Position=0  then Grayscale.Checked := True
                               else Grayscale.Checked := False;
  LSaturation.Caption := CmdFloat(0.05*SaturationBar.Position);
end;               
//------------------------------------------------------------
procedure TfrmMain.SaturationClick(Sender: TObject);
begin
  if Not(Saturation.Checked) then SaturationBar.Position := 20;
end;
//------------------------------------------------------------
procedure TfrmMain.MPEG2FormatFlagClick(Sender: TObject);
begin
  MPEG2Format.enabled := MPEG2FormatFlag.Checked;
end;   
//------------------------------------------------------------
procedure TfrmMain.MPEG4FormatFlagClick(Sender: TObject);
begin
  MPEG4Format.enabled := MPEG4FormatFlag.Checked;
end;
//------------------------------------------------------------
procedure TfrmMain.NoiseClick(Sender: TObject);
begin
  if Not(noise.Checked) then noiseValue.Position := 0;
end;
//------------------------------------------------------------
procedure TfrmMain.NoiseValueChange(Sender: TObject);
begin
  if noiseValue.Position>0 then noise.Checked := True
                           else noise.Checked := False;
end;   
//------------------------------------------------------------
procedure TfrmMain.pgControlRightChange(Sender: TObject);
begin
{  case pgControlRight.ActivePageIndex of
    0..3: btnCalc.Visible := True;
    else btnCalc.Visible := False;
  end;}
end;
//------------------------------------------------------------
procedure TfrmMain.Rotate180Click(Sender: TObject);
begin
  FlipV.Checked := True; 
  FlipH.Checked := True;
  Rotate.checked := True;
end;   
//------------------------------------------------------------
procedure TfrmMain.Rotate90AntiClick(Sender: TObject);
begin
  Rotate.checked := True;
end;
//------------------------------------------------------------
procedure TfrmMain.Rotate90Click(Sender: TObject);
begin
  Rotate.checked := True;
end;
//------------------------------------------------------------
procedure TfrmMain.IntegerChange(Sender: TObject);
begin
  ValidInteger(Sender);
end;       
//------------------------------------------------------------
procedure TfrmMain.FloatChange(Sender: TObject);
begin
  ValidFloat(Sender);
  UpdDiapoLength(Sender);
end;  
//------------------------------------------------------------
procedure TfrmMain.FLVFormatFlagClick(Sender: TObject);
begin
  FLVFormat.enabled := FLVFormatFlag.Checked;
end;
//------------------------------------------------------------
procedure TfrmMain.LaunchDVDStylerClick(Sender: TObject);
begin
  Common.LanceCommand(BinDVDStyler, '', True);
end;          
//------------------------------------------------------------
procedure TfrmMain.LaunchMPUIClick(Sender: TObject);
var
  Fic: string;
  i: integer;
begin
  Fic := '';
  if pgControlLeft.ActivePageIndex=0 then begin    
    for I := 0 to LVideos.Count - 1 do begin
      if LVideos.Selected[i] and (Fic='') then
        Fic := '"'+GetDirSlash(EVideoIn.Text) + LVideos.Items[i]+'"';
    end;
  end;

  Common.LanceCommand(BinMPUI, Fic, True);
end;        
//------------------------------------------------------------
procedure TfrmMain.LVideosChange(Sender: TObject);
begin
   //
end;

//------------------------------------------------------------
procedure TfrmMain.UpdDiapoLength(Sender: TObject);
var
  dImg, dTrans, Freq : double;
  n1, n2: integer;
  frate: string;
begin                           
  case pgControlRight.ActivePageIndex of
    0: frate := DVDPALFrameRate.Text;
    1: frate := DVDNTSCFrameRate.Text;
    2: frate := MPEG2FrameRate.Text;
    3: frate := MPEG4FrameRate.Text;
  end;
  val(DiapoDelay.Text, dImg, n1);
  val(TransitionDelay.Text, dTrans, n1);
  val(LeftStr(frate, 2), Freq, n1);
  n1 := LDiapos.SelCount;
  n2 := ToInt(dTrans*Freq);
  if LTransitions.ItemIndex=0 then dTrans := 0;
  if n1<1 then dTrans := 0;                   
  if LTransitions.ItemIndex<2 then n2 := 0;
  LDiapoLength.Caption := '  '+SecondsToTime(ToInt(dImg*n1+dTrans*(n1-1)));
  LDiapoSize.Caption := '  '+Str(ToInt((n2*(n1-1)+n1)*120/1024))+' Mo';
end;
//------------------------------------------------------------
procedure TfrmMain.FlipClick(Sender: TObject);
begin
  if FlipV.checked And FlipH.checked then begin
    Rotate.Checked := True;
    Rotate180.Checked := True;
  end else begin
    if Rotate180.checked and Rotate.checked then
      Rotate180.Checked := False;
  end;
end;
//------------------------------------------------------------
procedure TfrmMain.FormatChange(Sender: TObject);
begin
  ValidFormat(TLabeledEdit(Sender));
end;
//------------------------------------------------------------


end.
